---
title: Firefox 53 for developers
slug: Mozilla/Firefox/Releases/53
tags:
  - Firefox
  - Mozilla
  - Release Notes
---
<div>{{FirefoxSidebar}}</div><p>Firefox 53 was released on April 19, 2017. This article lists key changes that are useful not only for web developers, but also Firefox and Gecko developers as well as add-on developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<ul>
 <li>Avoid scrolling latency on highlighters given by APZ ({{bug(1312103)}}).</li>
 <li>Added option to <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_HTML#Copy_CSS_Path">copy the full CSS path</a> of an element ({{bug(1323700)}}).</li>
 <li>Devtools support for css-color-4 ({{bug(1310681)}}).</li>
 <li>Markup view: add a visual hint between opening and closing tags of a collapsed node ({{bug(1323193)}}).</li>
</ul>

<h3 id="CSS">CSS</h3>

<h4 id="New_features">New features</h4>

<ul>
 <li>The <code>mask-*</code> longhand properties (see <a href="/en-US/docs/Web/CSS/CSS_Masks">CSS Masks</a>) are all supported and available by default (see {{bug(1251161)}}).</li>
 <li>Added {{cssxref("caret-color")}} property ({{bug(1063162)}}).</li>
 <li>Implemented the {{cssxref("place-items")}}/{{cssxref("place-self")}}/{{cssxref("place-content")}} shorthands ({{bug(1319958)}}).</li>
 <li>Added <code>flow-root</code> value to {{cssxref("display")}} property ({{bug(1322191)}}).</li>
 <li>{{cssxref("tab-size", "-moz-tab-size")}} now accepts {{cssxref("&lt;length&gt;")}} values ({{bug(943918)}}), and is now animatable ({{bug(1308110)}}).</li>
 <li>{{cssxref("mask-mode")}}:luminance doesn't work on gradient masks ({{bug(1346265)}}).</li>
 <li>[css-grid] FR Unit in {{cssxref("grid-template-rows")}} not filling viewport ({{bug(1346699)}}).</li>
 <li>flex items aren't sorted according to "order", if they're separated by an abspos sibling ({{bug(1345873)}}).</li>
</ul>

<h4 id="Other_changes">Other changes</h4>

<ul>
 <li>Enable mask longhands on SVG elements ({{bug(1319667)}}).</li>
 <li>[css-grid] Fixed: <code>align-self</code>/<code>justify-self:stretch</code>/<code>normal</code> doesn't work on <code>&lt;table&gt;</code> grid items ({{bug(1316051)}}).</li>
 <li>Fixed: <code>clip-path: circle()</code> with large reference box and percentage radius does not render correctly ({{bug(1324713)}}.</li>
 <li>When applying a {{cssxref("text-transform")}} value of <code>uppercase</code> to Greek text, the accent on the disjunctive eta (ή) is no longer removed (see {{bug(1322989)}}).</li>
 <li>The availability of the <code>contents</code> value of {{cssxref("display")}} was controlled through the <code>layout.css.display-contents.enabled</code> pref. In Firefox 53 this pref has been removed altogether, so the value will always be available and can no longer be disabled ({{bug(1295788)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>ECMAScript 2015 semantics for the {{jsxref("Function.name")}} properties have been implemented. This includes inferred names on anonymous functions (<code>var foo = function() {}</code>) ({{bug(883377)}}).</li>
 <li>ECMAScript 2015 semantics for closing iterators have been implemented. This affects the <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of">for...of</a></code> loop, for example ({{bug(1147371)}}).</li>
 <li>The <a href="https://tc39.github.io/proposal-template-literal-revision/">Template Literal Revision proposal</a> that <a href="/en-US/docs/Web/JavaScript/Reference/Template_literals#Tagged_template_literals_and_escape_sequences">lifts escape sequence restrictions on tagged template literals</a> has been implemented ({{bug(1317375)}}).</li>
 <li>The non-standard <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/String#String_generic_methods">String generics</a> now present a deprecation warning in the console. Do not use them anymore, they will be removed in the future! ({{bug(1319926)}}).</li>
 <li>The static <code>length</code> property of {{jsxref("TypedArray")}} objects was changed from 3 to 0 as per ES2016 ({{bug(1317306)}}).</li>
 <li>{{jsxref("SharedArrayBuffer")}} can now be used in {{jsxref("DataView")}} objects ({{bug(1246597)}}).</li>
 <li>In earlier versions of the specification, {{jsxref("SharedArrayBuffer")}} objects needed to be explicitly transferred during <a href="/en-US/docs/Web/API/Web_Workers_API/Structured_clone_algorithm">structured cloning</a>. In the new specification they aren't <a href="/en-US/docs/Web/API/Transferable">transferable objects</a> anymore and thus must not be in the transfer list. The new behavior used to present a console warning only, but will now throw an error ({{bug(1302037)}}).</li>
 <li>The {{jsxref("ArrayBuffer")}} length is now limited to {{jsxref("Number.MAX_SAFE_INTEGER")}} (&gt;= 2 ** 53) ({{bug(1255128)}}).</li>
 <li>{{jsxref("Error.prototype")}} and other native error object prototypes like {{jsxref("RangeError.prototype")}} etc. are now ordinary objects instead of proper Error objects. (In particular, <code>Object.prototype.toString.call(Error.prototype)</code> is now <code>"[object Object]"</code> instead of <code>"[object Error]"</code>.) ({{bug(1213341)}}).</li>
</ul>

<h3 id="Events">Events</h3>

<ul>
 <li>CSS Transitions: The {{event("transitionstart")}}, {{event("transitionrun")}}, and {{event("transitioncancel")}} events have been implemented (see {{bug(1264125)}} and {{bug(1287983)}}).</li>
 <li>The {{domxref("CompositionEvent.CompositionEvent", "CompositionEvent")}} constructor has been implemented (see {{bug(1002256)}}).</li>
 <li>The {{domxref("MouseEvent.x")}} and {{domxref("MouseEvent.y")}} aliases of {{domxref("MouseEvent.clientX")}}/{{domxref("MouseEvent.clientY")}} have been implemented (see {{bug(424390)}}).</li>
 <li>The {{Event("auxclick")}} event and corresponding {{domxref("GlobalEventHandlers.onauxclick")}} handler have been implemented (see {{bug(1304044)}}).</li>
 <li>The {{Event("transitioncancel")}} event is now fired after a <a href="/en-US/docs/Web/CSS/CSS_Transitions">transition</a> is cancelled. See {{domxref("GlobalEventHandlers.ontransitioncancel")}} for more details and an example ({{bug("1264125")}}).</li>
</ul>

<h3 id="DOM">DOM</h3>

<ul>
 <li>The {{domxref("HTMLHyperLinkElementUtils.pathname", "pathname")}} and {{domxref("HTMLHyperLinkElementUtils.search", "search")}} {{domxref("HTMLHyperLinkElementUtils")}} properties previously returned the wrong parts of the URL. For example, for a URL of <code>http://z.com/x?a=true&amp;b=false</code>, <code>pathname</code> would return "<code>/x?a=true&amp;b=false"</code> and <code>search</code> would return "", rather than "<code>/x</code>" and "<code>?a=true&amp;b=false"</code> respectively. This has now been fixed ({{bug(1310483)}}).</li>
 <li>The {{domxref("URLSearchParams.URLSearchParams", "URLSearchParams()")}} constructor now accepts a {{domxref("USVString")}} or sequence of {{domxref("USVString")}}s as an init object ({{bug("1330678")}}).</li>
 <li>The {{domxref("Selection.setBaseAndExtent()")}} method of the <a href="/en-US/docs/Web/API/Selection_API">Selection API</a> is now implemented (see {{bug(1321623)}}).</li>
 <li>The <a href="https://html.spec.whatwg.org/multipage/forms.html#fakepath-srsly">"fakepath"</a> addition to <code>file</code> type {{htmlelement("input")}} <code>values</code> has been implemented in Gecko, giving it parity with other browsers (see {{bug(1274596)}}).</li>
 <li>{{domxref("Node.getRootNode()")}} has been implemented, replacing the deprecated {{domxref("Node.rootNode")}} property ({{bug(1269155)}}).</li>
 <li>Own properties of {{domxref("Plugin")}} and {{domxref("PluginArray")}} objects are no longer enumerable ({{bug("1270366")}}).</li>
 <li>Named properties of {{domxref("MimeTypeArray")}} objects are no longer enumerable ({{bug("1270364")}}).</li>
 <li>The <a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a> now has a new permission name available — <code>persistent-storage</code> — as used when making a {{domxref("Permissions.query()")}} (see {{bug(1270038)}}). This allows an origin to use a persistent box (i.e <a href="https://storage.spec.whatwg.org/#persistence">persistent storage</a>) for its storage, as per the <a href="https://storage.spec.whatwg.org/">Storage API</a>.</li>
 <li>The {{domxref("Performance.timeOrigin")}} property has been implemented ({{bug(1313420)}}).</li>
</ul>

<h3 id="Workers_and_service_workers">Workers and service workers</h3>

<ul>
 <li>The <a href="/en-US/docs/Web/API/Network_Information_API">Network Information API</a> is now available in workers (see {{bug(1323172)}}).</li>
 <li><a href="/en-US/docs/Web/API/Server-sent_events">Server-sent events</a> can now be used from workers (see {{bug(1267903)}}).</li>
 <li>{{domxref("ExtendableEvent.waitUntil", "ExtendableEvent.waitUntil()")}} can now be called asynchronously (see {{bug(1263304)}}).</li>
</ul>

<h3 id="WebGL">WebGL</h3>

<ul>
 <li>The {{domxref("WEBGL_compressed_texture_astc")}} WebGL extension has been implemented ({{bug(1250077)}}).</li>
 <li>The {{domxref("WEBGL_debug_renderer_info")}} WebGL extension is now enabled by default ({{bug(1336645)}}).</li>
</ul>

<h3 id="Audio_video_and_media">Audio, video, and media</h3>

<h4 id="General">General</h4>

<ul>
 <li>Beginning in <strong>Firefox 53 for Android</strong>, decoding of media is handled out-of-process for improved performance on multi-core systems ({{bug(1333323)}}).</li>
</ul>

<h4 id="Media_elements">Media elements</h4>

<ul>
 <li>The {{domxref("HTMLMediaElement.play()")}} method, used to begin playback of media in any media element, now returns a {{jsxref("Promise")}} which is fulfilled when playback begins and is rejected if an error occurs ({{bug(1244768)}}).</li>
</ul>

<h4 id="Web_Audio_API">Web Audio API</h4>

<ul>
 <li>The {{domxref("AudioScheduledSourceNode")}} interface has been added and the {{domxref("AudioBufferSourceNode")}}, {{domxref("ConstantSourceNode")}}, and {{domxref("OscillatorNode")}} interfaces are now based on it ({{bug("1324568")}}).</li>
 <li>All the different audio node types have had constructors added to them ({{bug(1322883)}}).</li>
</ul>

<h4 id="WebRTC">WebRTC</h4>

<ul>
 <li>The {{domxref("RTCPeerConnection")}} methods {{domxref("RTCPeerConnection.createOffer", "createOffer()")}} and {{domxref("RTCPeerConnection.createAnswer", "createAnswer()")}} now return a {{jsxref("Promise")}} that returns an object conforming to the dictionary {{domxref("RTCSessionDescriptionInit")}} instead of returning an {{domxref("RTCSessionDescription")}} directly. Existing code will continue to work, but <a href="/en-US/docs/Web/API/RTCPeerConnection/setLocalDescription#About_the_session_description_parameter">new code can be written more</a>.</li>
 <li>Similarly, the {{domxref("RTCPeerConnection")}} methods {{domxref("RTCPeerConnection.setLocalDescription", "setLocalDescription()")}} and {{domxref("RTCPeerConnection.setRemoteDescription", "setRemoteDescription()")}} now accept as input an object conforming to the dictionary {{domxref("RTCSessionDescriptionInit")}}. Existing code continues to work, but <a href="/en-US/docs/Web/API/RTCPeerConnection/setLocalDescription#About_the_session_description_parameter">can be simplified</a>.</li>
 <li>{{domxref("RTCPeerConnection.addIceCandidate()")}} now accepts as input an object conforming to the {{domxref("RTCIceCandidateInit")}} dictionary. This is compatible with existing code but allows new code to be written slightly more when used in tandem with the changes listed above ({{bug(1263312)}}).</li>
 <li>{{Glossary("DTMF")}} support is now enabled by default using {{domxref("RTCDTMFSender")}}. See <a href="/en-US/docs/Web/API/WebRTC_API/Using_DTMF">Using DTMF with WebRTC</a> for more information on how this works.</li>
</ul>

<h3 id="HTTPNetworking">HTTP/Networking</h3>

<ul>
 <li>Gecko now has a pref available in <code>about:config</code> to allow users to set their default {{HTTPHeader("Referrer-Policy")}} —<span class="quote"> <code>network.http.referer.userControlPolicy</code></span> ({{bug("1304623")}}).<span class="quote"> Possible values are:</span>

  <ul>
   <li>0 — <code>no-referrer</code></li>
   <li>1 — <code>same-origin</code></li>
   <li>2 — <code>strict-origin-when-cross-origin</code></li>
   <li>3 — <code>no-referrer-when-downgrade</code> (the default)</li>
  </ul>
 </li>
 <li>Support for Next Protocol Negotiation (NPN) has been removed in favor of <a href="https://en.wikipedia.org/wiki/Application-Layer_Protocol_Negotiation">Application-Layer Protocol Negotiation</a> (ALPN) — see {{bug("1248198")}}.</li>
 <li>The {{httpheader("Large-Allocation")}} HTTP header is now available by default, and no longer hidden behind a pref ({{bug(1331083)}}).</li>
</ul>

<h3 id="SVG">SVG</h3>

<ul>
 <li>Partly implemented {{domxref("SVGGeometryElement")}} interface ({{bug(1239100)}}).</li>
</ul>

<h2 id="Removals_from_the_web_platform">Removals from the web platform</h2>

<h3 id="HTMLXML">HTML/XML</h3>

<ul>
 <li>The <span id="summary_alias_container"><span id="short_desc_nonedit_display"><code>dom.details_element.enabled</code> pref — which controlled enabling/disabling {{htmlelement("details")}} and {{htmlelement("summary")}} element support in Firefox — has now been removed from <code>about:config</code>. These elements (which were first enabled by default in Firefox 49) can no longer be disabled. See {{bug(1271549)}}.</span></span></li>
 <li><span><span>The <code>mozapp</code> attribute of the {{htmlelement("iframe")}} element</span></span>/{{domxref("HTMLIFrameElement")}} interface has been removed — this was used to enable a Firefox OS app to be embedded in a moz <a href="/en-US/docs/Mozilla/Gecko/Chrome/API/Browser_API">Browser API</a> <code>&lt;iframe&gt;</code> ({{bug(1310845)}}).</li>
 <li>The {{domxref("HTMLIFrameElement.setInputMethodActive()")}} method and <code>InputMethod</code> interface (used to set and manage IMEs on Firefox OS apps) has been removed ({{bug(1313169)}}).</li>
</ul>

<h3 id="CSS_2"><span><span>CSS</span></span></h3>

<ul>
 <li>Removed {{property_prefix("-moz")}} prefixed variant of {{cssxref(":dir", ":dir()")}} pseudo-class ({{bug(1270406)}}).</li>
 <li>The <code>-moz</code> prefixed version of {{cssxref("text-align-last")}} got removed ({{bug(1276808)}}).</li>
 <li>Removed {{property_prefix("-moz")}} prefixed variant of {{cssxref("calc()")}} method ({{bug(1331296)}}).</li>
 <li>The proprietary <code>-moz-samplesize</code> media fragment (added to aid in delivery of downsampled images to low memory Firefox OS devices; see {{bug(854795)}}) has been removed ({{bug(1311246)}}).</li>
</ul>

<h3 id="JavaScript_2">JavaScript</h3>

<ul>
 <li>The non-standard {{jsxref("ArrayBuffer.slice()")}} method has been removed (but the standardized version {{jsxref("ArrayBuffer.prototype.slice()")}} is kept, see {{bug(1313112)}}).</li>
</ul>

<h3 id="APIs">APIs</h3>

<ul>
 <li>The <a href="/en-US/docs/Archive/B2G_OS/API/WiFi_Information_API">Wifi information API</a>, Speaker Manager API, and Tethering API, and <a href="/en-US/docs/Archive/B2G_OS/API/Settings_API">Settings API</a> have been removed from the platform (see {{bug(1313788)}}, {{bug(1317853)}}, {{bug(1313789)}}, and {{bug(1313155)}} respectively).</li>
</ul>

<h3 id="Other">Other</h3>

<ul>
 <li>The <code>legacycaller</code> has been removed from the {{domxref("HTMLEmbedElement")}} and {{domxref("HTMLObjectElement")}} interfaces ({{bug(909656)}}).</li>
</ul>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="WebExtensions">WebExtensions</h3>

<p>New APIs:</p>

<ul>
 <li><code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browsingData">browsingData</a></code></li>
 <li><code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/identity">identity</a></code></li>
 <li><code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/contextualIdentities">contextualIdentities</a></code></li>
</ul>

<p>Enhanced APIs:</p>

<ul>
 <li><code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/storage/sync">storage.sync</a></code></li>
 <li><code>page_action</code>, <code>browser_action</code>, <code>password</code>, <code>tab</code> <a href="/en-US/Add-ons/WebExtensions/API/contextMenus/ContextType">context types</a> in <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/contextMenus">contextMenus</a></code></li>
 <li><code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/webRequest/onBeforeRequest">webRequest.onBeforeRequest</a></code> now supports <code>requestBody</code></li>
 <li><code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/insertCSS">tabs.insertCSS</a></code> now supports <code>cssOrigin</code>, enabling you to insert user style sheets.</li>
</ul>

<h3 id="JavaScript_code_modules">JavaScript code modules</h3>

<ul>
 <li>The asynchronous <a href="../../../Add-ons/Add-on_Manager/AddonManager">AddonManager APIs</a> now support {{jsxref("Promise", "Promises")}} as well as callbacks ({{bug(987512)}}.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/53">Site Compatibility for Firefox 53</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(52)}}</p>
